/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.23 Revision 1.392
1# Copyright 1999-2003 Gentoo Technologies, Inc. 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.23 2003/03/01 03:38:40 vapier Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.392 2012/05/11 14:22:01 vapier Exp $
4#
5# Author: Martin Schlemmer <azarah@gentoo.org>
6#
7# This eclass is for general purpose functions that most ebuilds
8# have to implement themselves.
9#
10# NB: If you add anything, please comment it!
11 4
12ECLASS=eutils 5# @ECLASS: eutils.eclass
13INHERITED="$INHERITED $ECLASS" 6# @MAINTAINER:
7# base-system@gentoo.org
8# @BLURB: many extra (but common) functions that are used in ebuilds
9# @DESCRIPTION:
10# The eutils eclass contains a suite of functions that complement
11# the ones that ebuild.sh already contain. The idea is that the functions
12# are not required in all ebuilds but enough utilize them to have a common
13# home rather than having multiple ebuilds implementing the same thing.
14#
15# Due to the nature of this eclass, some functions may have maintainers
16# different from the overall eclass!
14 17
15newdepend "!bootstrap? ( sys-devel/patch )" 18if [[ ${___ECLASS_ONCE_EUTILS} != "recur -_+^+_- spank" ]] ; then
19___ECLASS_ONCE_EUTILS="recur -_+^+_- spank"
20
21inherit multilib user
16 22
17DESCRIPTION="Based on the ${ECLASS} eclass" 23DESCRIPTION="Based on the ${ECLASS} eclass"
18 24
19# This function generate linker scripts in /usr/lib for dynamic 25if has "${EAPI:-0}" 0 1 2; then
20# libs in /lib. This is to fix linking problems when you have
21# the .so in /lib, and the .a in /usr/lib. What happens is that
22# in some cases when linking dynamic, the .a in /usr/lib is used
23# instead of the .so in /lib due to gcc/libtool tweaking ld's
24# library search path. This cause many builds to fail.
25# See bug #4411 for more info.
26#
27# To use, simply call:
28#
29# gen_usr_ldscript libfoo.so
30#
31# Note that you should in general use the unversioned name of
32# the library, as ldconfig should usually update it correctly
33# to point to the latest version of the library present.
34#
35# <azarah@gentoo.org> (26 Oct 2002)
36#
37gen_usr_ldscript() {
38 26
39 # Just make sure it exists 27# @FUNCTION: epause
40 dodir /usr/lib 28# @USAGE: [seconds]
41 29# @DESCRIPTION:
42 cat > ${D}/usr/lib/$1 <<"END_LDSCRIPT" 30# Sleep for the specified number of seconds (default of 5 seconds). Useful when
43/* GNU ld script 31# printing a message the user should probably be reading and often used in
44 Because Gentoo have critical dynamic libraries 32# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set,
45 in /lib, and the static versions in /usr/lib, we 33# don't wait at all. Defined in EAPIs 0 1 and 2.
46 need to have a "fake" dynamic lib in /usr/lib, 34epause() {
47 otherwise we run into linking problems. 35 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
48 See bug #4411 on http://bugs.gentoo.org/ for
49 more info. */
50GROUP ( /lib/libxxx )
51END_LDSCRIPT
52
53 dosed "s:libxxx:$1:" /usr/lib/$1
54
55 return 0
56} 36}
57 37
58# Simple function to draw a line consisting of '=' the same length as $* 38# @FUNCTION: ebeep
59# 39# @USAGE: [number of beeps]
60# <azarah@gentoo.org> (11 Nov 2002) 40# @DESCRIPTION:
61# 41# Issue the specified number of beeps (default of 5 beeps). Useful when
62draw_line() { 42# printing a message the user should probably be reading and often used in
43# conjunction with the epause function. If the EBEEP_IGNORE env var is set,
44# don't beep at all. Defined in EAPIs 0 1 and 2.
45ebeep() {
63 local i=0 46 local n
64 local str_length="" 47 if [[ -z ${EBEEP_IGNORE} ]] ; then
65 48 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
66 # Handle calls that do not have args, or wc not being installed ...
67 if [ -z "$1" -o ! -x "$(which wc 2>/dev/null)" ]
68 then
69 echo "==============================================================="
70 return 0
71 fi
72
73 # Get the length of $*
74 str_length="$(echo -n "$*" | wc -m)"
75
76 while [ "$i" -lt "${str_length}" ]
77 do
78 echo -n "=" 49 echo -ne "\a"
79 50 sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null
80 i=$((i + 1)) 51 echo -ne "\a"
52 sleep 1
81 done 53 done
54 fi
55}
82 56
83 echo 57else
84 58
59ebeep() {
60 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
61}
62
63epause() {
64 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
65}
66
67fi
68
69# @FUNCTION: eqawarn
70# @USAGE: [message]
71# @DESCRIPTION:
72# Proxy to ewarn for package managers that don't provide eqawarn and use the PM
73# implementation if available. Reuses PORTAGE_ELOG_CLASSES as set by the dev
74# profile.
75if ! declare -F eqawarn >/dev/null ; then
76 eqawarn() {
77 has qa ${PORTAGE_ELOG_CLASSES} && ewarn "$@"
78 :
79 }
80fi
81
82# @FUNCTION: ecvs_clean
83# @USAGE: [list of dirs]
84# @DESCRIPTION:
85# Remove CVS directories recursiveley. Useful when a source tarball contains
86# internal CVS directories. Defaults to $PWD.
87ecvs_clean() {
88 [[ -z $* ]] && set -- .
89 find "$@" -type d -name 'CVS' -prune -print0 | xargs -0 rm -rf
90 find "$@" -type f -name '.cvs*' -print0 | xargs -0 rm -rf
91}
92
93# @FUNCTION: esvn_clean
94# @USAGE: [list of dirs]
95# @DESCRIPTION:
96# Remove .svn directories recursiveley. Useful when a source tarball contains
97# internal Subversion directories. Defaults to $PWD.
98esvn_clean() {
99 [[ -z $* ]] && set -- .
100 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
101}
102
103# @FUNCTION: estack_push
104# @USAGE: <stack> [items to push]
105# @DESCRIPTION:
106# Push any number of items onto the specified stack. Pick a name that
107# is a valid variable (i.e. stick to alphanumerics), and push as many
108# items as you like onto the stack at once.
109#
110# The following code snippet will echo 5, then 4, then 3, then ...
111# @CODE
112# estack_push mystack 1 2 3 4 5
113# while estack_pop mystack i ; do
114# echo "${i}"
115# done
116# @CODE
117estack_push() {
118 [[ $# -eq 0 ]] && die "estack_push: incorrect # of arguments"
119 local stack_name="__ESTACK_$1__" ; shift
120 eval ${stack_name}+=\( \"\$@\" \)
121}
122
123# @FUNCTION: estack_pop
124# @USAGE: <stack> [variable]
125# @DESCRIPTION:
126# Pop a single item off the specified stack. If a variable is specified,
127# the popped item is stored there. If no more items are available, return
128# 1, else return 0. See estack_push for more info.
129estack_pop() {
130 [[ $# -eq 0 || $# -gt 2 ]] && die "estack_pop: incorrect # of arguments"
131
132 # We use the fugly __estack_xxx var names to avoid collision with
133 # passing back the return value. If we used "local i" and the
134 # caller ran `estack_pop ... i`, we'd end up setting the local
135 # copy of "i" rather than the caller's copy. The __estack_xxx
136 # garbage is preferable to using $1/$2 everywhere as that is a
137 # bit harder to read.
138 local __estack_name="__ESTACK_$1__" ; shift
139 local __estack_retvar=$1 ; shift
140 eval local __estack_i=\${#${__estack_name}\[@\]}
141 # Don't warn -- let the caller interpret this as a failure
142 # or as normal behavior (akin to `shift`)
143 [[ $(( --__estack_i )) -eq -1 ]] && return 1
144
145 if [[ -n ${__estack_retvar} ]] ; then
146 eval ${__estack_retvar}=\"\${${__estack_name}\[${__estack_i}\]}\"
147 fi
148 eval unset ${__estack_name}\[${__estack_i}\]
149}
150
151# @FUNCTION: eshopts_push
152# @USAGE: [options to `set` or `shopt`]
153# @DESCRIPTION:
154# Often times code will want to enable a shell option to change code behavior.
155# Since changing shell options can easily break other pieces of code (which
156# assume the default state), eshopts_push is used to (1) push the current shell
157# options onto a stack and (2) pass the specified arguments to set.
158#
159# If the first argument is '-s' or '-u', we assume you want to call `shopt`
160# rather than `set` as there are some options only available via that.
161#
162# A common example is to disable shell globbing so that special meaning/care
163# may be used with variables/arguments to custom functions. That would be:
164# @CODE
165# eshopts_push -s noglob
166# for x in ${foo} ; do
167# if ...some check... ; then
168# eshopts_pop
85 return 0 169# return 0
170# fi
171# done
172# eshopts_pop
173# @CODE
174eshopts_push() {
175 if [[ $1 == -[su] ]] ; then
176 estack_push eshopts "$(shopt -p)"
177 [[ $# -eq 0 ]] && return 0
178 shopt "$@" || die "${FUNCNAME}: bad options to shopt: $*"
179 else
180 estack_push eshopts $-
181 [[ $# -eq 0 ]] && return 0
182 set "$@" || die "${FUNCNAME}: bad options to set: $*"
183 fi
86} 184}
87 185
88# Default directory where patches are located 186# @FUNCTION: eshopts_pop
187# @USAGE:
188# @DESCRIPTION:
189# Restore the shell options to the state saved with the corresponding
190# eshopts_push call. See that function for more details.
191eshopts_pop() {
192 local s
193 estack_pop eshopts s || die "${FUNCNAME}: unbalanced push"
194 if [[ ${s} == "shopt -"* ]] ; then
195 eval "${s}" || die "${FUNCNAME}: sanity: invalid shopt options: ${s}"
196 else
197 set +$- || die "${FUNCNAME}: sanity: invalid shell settings: $-"
198 set -${s} || die "${FUNCNAME}: sanity: unable to restore saved shell settings: ${s}"
199 fi
200}
201
202# @FUNCTION: eumask_push
203# @USAGE: <new umask>
204# @DESCRIPTION:
205# Set the umask to the new value specified while saving the previous
206# value onto a stack. Useful for temporarily changing the umask.
207eumask_push() {
208 estack_push eumask "$(umask)"
209 umask "$@" || die "${FUNCNAME}: bad options to umask: $*"
210}
211
212# @FUNCTION: eumask_pop
213# @USAGE:
214# @DESCRIPTION:
215# Restore the previous umask state.
216eumask_pop() {
217 [[ $# -eq 0 ]] || die "${FUNCNAME}: we take no options"
218 local s
219 estack_pop eumask s || die "${FUNCNAME}: unbalanced push"
220 umask ${s} || die "${FUNCNAME}: sanity: could not restore umask: ${s}"
221}
222
223# @VARIABLE: EPATCH_SOURCE
224# @DESCRIPTION:
225# Default directory to search for patches.
89EPATCH_SOURCE="${WORKDIR}/patch" 226EPATCH_SOURCE="${WORKDIR}/patch"
90# Default extension for patches 227# @VARIABLE: EPATCH_SUFFIX
228# @DESCRIPTION:
229# Default extension for patches (do not prefix the period yourself).
91EPATCH_SUFFIX="patch.bz2" 230EPATCH_SUFFIX="patch.bz2"
92# Default options for patch 231# @VARIABLE: EPATCH_OPTS
232# @DESCRIPTION:
233# Options to pass to patch. Meant for ebuild/package-specific tweaking
234# such as forcing the patch level (-p#) or fuzz (-F#) factor. Note that
235# for single patch tweaking, you can also pass flags directly to epatch.
93EPATCH_OPTS="" 236EPATCH_OPTS=""
237# @VARIABLE: EPATCH_COMMON_OPTS
238# @DESCRIPTION:
239# Common options to pass to `patch`. You probably should never need to
240# change these. If you do, please discuss it with base-system first to
241# be sure.
242# @CODE
243# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
244# --no-backup-if-mismatch - do not leave .orig files behind
245# -E - automatically remove empty files
246# @CODE
247EPATCH_COMMON_OPTS="-g0 -E --no-backup-if-mismatch"
248# @VARIABLE: EPATCH_EXCLUDE
249# @DESCRIPTION:
94# List of patches not to apply. Not this is only file names, 250# List of patches not to apply. Note this is only file names,
95# and not the full path .. 251# and not the full path. Globs accepted.
96EPATCH_EXCLUDE="" 252EPATCH_EXCLUDE=""
253# @VARIABLE: EPATCH_SINGLE_MSG
254# @DESCRIPTION:
97# Change the printed message for a single patch. 255# Change the printed message for a single patch.
98EPATCH_SINGLE_MSG="" 256EPATCH_SINGLE_MSG=""
257# @VARIABLE: EPATCH_MULTI_MSG
258# @DESCRIPTION:
259# Change the printed message for multiple patches.
260EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
261# @VARIABLE: EPATCH_FORCE
262# @DESCRIPTION:
263# Only require patches to match EPATCH_SUFFIX rather than the extended
264# arch naming style.
265EPATCH_FORCE="no"
99 266
100# This function is for bulk patching, or in theory for just one 267# @FUNCTION: epatch
101# or two patches. 268# @USAGE: [options] [patches] [dirs of patches]
269# @DESCRIPTION:
270# epatch is designed to greatly simplify the application of patches. It can
271# process patch files directly, or directories of patches. The patches may be
272# compressed (bzip/gzip/etc...) or plain text. You generally need not specify
273# the -p option as epatch will automatically attempt -p0 to -p5 until things
274# apply successfully.
102# 275#
103# It should work with .bz2, .gz, .zip and plain text patches. 276# If you do not specify any patches/dirs, then epatch will default to the
104# Currently all patches should be the same format. 277# directory specified by EPATCH_SOURCE.
105# 278#
106# You do not have to specify '-p' option to patch, as it will 279# Any options specified that start with a dash will be passed down to patch
107# try with -p0 to -p5 until it succeed, or fail at -p5. 280# for this specific invocation. As soon as an arg w/out a dash is found, then
281# arg processing stops.
108# 282#
109# Above EPATCH_* variables can be used to control various defaults, 283# When processing directories, epatch will apply all patches that match:
110# bug they should be left as is to ensure an ebuild can rely on 284# @CODE
111# them for. 285# if ${EPATCH_FORCE} != "yes"
112#
113# Patches are applied in current directory.
114#
115# Bulk Patches should preferibly have the form of:
116#
117# ??_${ARCH}_foo.${EPATCH_SUFFIX} 286# ??_${ARCH}_foo.${EPATCH_SUFFIX}
287# else
288# *.${EPATCH_SUFFIX}
289# @CODE
290# The leading ?? are typically numbers used to force consistent patch ordering.
291# The arch field is used to apply patches only for the host architecture with
292# the special value of "all" means apply for everyone. Note that using values
293# other than "all" is highly discouraged -- you should apply patches all the
294# time and let architecture details be detected at configure/compile time.
118# 295#
119# For example: 296# If EPATCH_SUFFIX is empty, then no period before it is implied when searching
297# for patches to apply.
120# 298#
121# 01_all_misc-fix.patch.bz2 299# Refer to the other EPATCH_xxx variables for more customization of behavior.
122# 02_sparc_another-fix.patch.bz2
123#
124# This ensures that there are a set order, and you can have ARCH
125# specific patches.
126#
127# If you however give an argument to epatch(), it will treat it as a
128# single patch that need to be applied if its a file. If on the other
129# hand its a directory, it will set EPATCH_SOURCE to this.
130#
131# <azarah@gentoo.org> (10 Nov 2002)
132#
133epatch() { 300epatch() {
134 local PIPE_CMD="" 301 _epatch_draw_line() {
135 local STDERR_TARGET="${T}/$$.out" 302 # create a line of same length as input string
136 local PATCH_TARGET="${T}/$$.patch" 303 [[ -z $1 ]] && set "$(printf "%65s" '')"
137 local PATCH_SUFFIX="" 304 echo "${1//?/=}"
305 }
306
307 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
308
309 # First process options. We localize the EPATCH_OPTS setting
310 # from above so that we can pass it on in the loop below with
311 # any additional values the user has specified.
312 local EPATCH_OPTS=( ${EPATCH_OPTS[*]} )
313 while [[ $# -gt 0 ]] ; do
314 case $1 in
315 -*) EPATCH_OPTS+=( "$1" ) ;;
316 *) break ;;
317 esac
318 shift
319 done
320
321 # Let the rest of the code process one user arg at a time --
322 # each arg may expand into multiple patches, and each arg may
323 # need to start off with the default global EPATCH_xxx values
324 if [[ $# -gt 1 ]] ; then
325 local m
326 for m in "$@" ; do
327 epatch "${m}"
328 done
329 return 0
330 fi
331
138 local SINGLE_PATCH="no" 332 local SINGLE_PATCH="no"
139 local x="" 333 # no args means process ${EPATCH_SOURCE}
334 [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
140 335
141 if [ "$#" -gt 1 ] 336 if [[ -f $1 ]] ; then
142 then
143 eerror "Invalid arguments to epatch()"
144 die "Invalid arguments to epatch()"
145 fi
146
147 if [ -n "$1" -a -f "$1" ]
148 then
149 SINGLE_PATCH="yes" 337 SINGLE_PATCH="yes"
150 338 set -- "$1"
151 local EPATCH_SOURCE="$1" 339 # Use the suffix from the single patch (localize it); the code
340 # below will find the suffix for us
152 local EPATCH_SUFFIX="${1##*\.}" 341 local EPATCH_SUFFIX=$1
153 342
154 elif [ -n "$1" -a -d "$1" ] 343 elif [[ -d $1 ]] ; then
155 then 344 # Some people like to make dirs of patches w/out suffixes (vim)
156 local EPATCH_SOURCE="$1/*.${EPATCH_SUFFIX}" 345 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
346
347 elif [[ -f ${EPATCH_SOURCE}/$1 ]] ; then
348 # Re-use EPATCH_SOURCE as a search dir
349 epatch "${EPATCH_SOURCE}/$1"
350 return $?
351
157 else 352 else
158 if [ ! -d ${EPATCH_SOURCE} ] 353 # sanity check ... if it isn't a dir or file, wtf man ?
354 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
355 echo
356 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
357 eerror
358 eerror " ${EPATCH_SOURCE}"
359 eerror " ( ${EPATCH_SOURCE##*/} )"
360 echo
361 die "Cannot find \$EPATCH_SOURCE!"
362 fi
363
364 # Now that we know we're actually going to apply something, merge
365 # all of the patch options back in to a single variable for below.
366 EPATCH_OPTS="${EPATCH_COMMON_OPTS} ${EPATCH_OPTS[*]}"
367
368 local PIPE_CMD
369 case ${EPATCH_SUFFIX##*\.} in
370 xz) PIPE_CMD="xz -dc" ;;
371 lzma) PIPE_CMD="lzma -dc" ;;
372 bz2) PIPE_CMD="bzip2 -dc" ;;
373 gz|Z|z) PIPE_CMD="gzip -dc" ;;
374 ZIP|zip) PIPE_CMD="unzip -p" ;;
375 *) ;;
376 esac
377
378 [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
379
380 local x
381 for x in "$@" ; do
382 # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
383 # didn't match anything, ignore continue on
384 [[ ! -f ${x} ]] && continue
385
386 local patchname=${x##*/}
387
388 # Apply single patches, or forced sets of patches, or
389 # patches with ARCH dependant names.
390 # ???_arch_foo.patch
391 # Else, skip this input altogether
392 local a=${patchname#*_} # strip the ???_
393 a=${a%%_*} # strip the _foo.patch
394 if ! [[ ${SINGLE_PATCH} == "yes" || \
395 ${EPATCH_FORCE} == "yes" || \
396 ${a} == all || \
397 ${a} == ${ARCH} ]]
159 then 398 then
160 if [ -n "$1" -a "${EPATCH_SOURCE}" = "${WORKDIR}/patch" ] 399 continue
161 then 400 fi
162 EPATCH_SOURCE="$1" 401
402 # Let people filter things dynamically
403 if [[ -n ${EPATCH_EXCLUDE} ]] ; then
404 # let people use globs in the exclude
405 eshopts_push -o noglob
406
407 local ex
408 for ex in ${EPATCH_EXCLUDE} ; do
409 if [[ ${patchname} == ${ex} ]] ; then
410 eshopts_pop
411 continue 2
412 fi
413 done
414
415 eshopts_pop
416 fi
417
418 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
419 if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
420 einfo "${EPATCH_SINGLE_MSG}"
421 else
422 einfo "Applying ${patchname} ..."
163 fi 423 fi
424 else
425 einfo " ${patchname} ..."
426 fi
164 427
428 # most of the time, there will only be one run per unique name,
429 # but if there are more, make sure we get unique log filenames
430 local STDERR_TARGET="${T}/${patchname}.out"
431 if [[ -e ${STDERR_TARGET} ]] ; then
432 STDERR_TARGET="${T}/${patchname}-$$.out"
433 fi
434
435 printf "***** %s *****\nPWD: %s\n\n" "${patchname}" "${PWD}" > "${STDERR_TARGET}"
436
437 # Decompress the patch if need be
438 local count=0
439 local PATCH_TARGET
440 if [[ -n ${PIPE_CMD} ]] ; then
441 PATCH_TARGET="${T}/$$.patch"
442 echo "PIPE_COMMAND: ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
443
444 if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
445 echo
446 eerror "Could not extract patch!"
447 #die "Could not extract patch!"
448 count=5
449 break
450 fi
451 else
452 PATCH_TARGET=${x}
453 fi
454
455 # Check for absolute paths in patches. If sandbox is disabled,
456 # people could (accidently) patch files in the root filesystem.
457 # Or trigger other unpleasantries #237667. So disallow -p0 on
458 # such patches.
459 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
460 if [[ -n ${abs_paths} ]] ; then
461 count=1
462 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
463 fi
464 # Similar reason, but with relative paths.
465 local rel_paths=$(egrep -n '^[-+]{3} [^ ]*[.][.]/' "${PATCH_TARGET}")
466 if [[ -n ${rel_paths} ]] ; then
467 eqawarn "QA Notice: Your patch uses relative paths '../'."
468 eqawarn " In the future this will cause a failure."
469 eqawarn "${rel_paths}"
470 fi
471
472 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
473 local patch_cmd
474 while [[ ${count} -lt 5 ]] ; do
475 patch_cmd="${BASH_ALIASES[patch]:-patch} -p${count} ${EPATCH_OPTS}"
476
477 # Generate some useful debug info ...
478 (
479 _epatch_draw_line "***** ${patchname} *****"
165 echo 480 echo
166 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:" 481 echo "PATCH COMMAND: ${patch_cmd} < '${PATCH_TARGET}'"
482 echo
483 _epatch_draw_line "***** ${patchname} *****"
484 ${patch_cmd} --dry-run -f < "${PATCH_TARGET}" 2>&1
485 ret=$?
486 echo
487 echo "patch program exited with status ${ret}"
488 exit ${ret}
489 ) >> "${STDERR_TARGET}"
490
491 if [ $? -eq 0 ] ; then
492 (
493 _epatch_draw_line "***** ${patchname} *****"
494 echo
495 echo "ACTUALLY APPLYING ${patchname} ..."
496 echo
497 _epatch_draw_line "***** ${patchname} *****"
498 ${patch_cmd} < "${PATCH_TARGET}" 2>&1
499 ret=$?
500 echo
501 echo "patch program exited with status ${ret}"
502 exit ${ret}
503 ) >> "${STDERR_TARGET}"
504
505 if [ $? -ne 0 ] ; then
506 echo
507 eerror "A dry-run of patch command succeeded, but actually"
508 eerror "applying the patch failed!"
509 #die "Real world sux compared to the dreamworld!"
510 count=5
511 fi
512 break
513 fi
514
515 : $(( count++ ))
516 done
517
518 # if we had to decompress the patch, delete the temp one
519 if [[ -n ${PIPE_CMD} ]] ; then
520 rm -f "${PATCH_TARGET}"
521 fi
522
523 if [[ ${count} -ge 5 ]] ; then
524 echo
525 eerror "Failed Patch: ${patchname} !"
526 eerror " ( ${PATCH_TARGET} )"
167 eerror 527 eerror
168 eerror " ${EPATCH_SOURCE}" 528 eerror "Include in your bugreport the contents of:"
529 eerror
530 eerror " ${STDERR_TARGET}"
169 echo 531 echo
170 die "Cannot find \$EPATCH_SOURCE!" 532 die "Failed Patch: ${patchname}!"
171 fi
172
173 local EPATCH_SOURCE="${EPATCH_SOURCE}/*.${EPATCH_SUFFIX}"
174 fi 533 fi
175 534
176 case ${EPATCH_SUFFIX##*\.} in 535 # if everything worked, delete the full debug patch log
177 bz2) 536 rm -f "${STDERR_TARGET}"
178 PIPE_CMD="bzip2 -dc" 537
179 PATCH_SUFFIX="bz2" 538 # then log away the exact stuff for people to review later
180 ;; 539 cat <<-EOF >> "${T}/epatch.log"
181 gz|Z|z) 540 PATCH: ${x}
182 PIPE_CMD="gzip -dc" 541 CMD: ${patch_cmd}
183 PATCH_SUFFIX="gz" 542 PWD: ${PWD}
184 ;; 543
185 ZIP|zip) 544 EOF
186 PIPE_CMD="unzip -p" 545 eend 0
187 PATCH_SUFFIX="zip" 546 done
188 ;; 547
189 *) 548 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
190 PIPE_CMD="cat" 549 : # everything worked
550}
551
552# @FUNCTION: epatch_user
553# @USAGE:
554# @DESCRIPTION:
555# Applies user-provided patches to the source tree. The patches are
556# taken from /etc/portage/patches/<CATEGORY>/<PF|P|PN>/, where the first
557# of these three directories to exist will be the one to use, ignoring
558# any more general directories which might exist as well. They must end
559# in ".patch" to be applied.
560#
561# User patches are intended for quick testing of patches without ebuild
562# modifications, as well as for permanent customizations a user might
563# desire. Obviously, there can be no official support for arbitrarily
564# patched ebuilds. So whenever a build log in a bug report mentions that
565# user patches were applied, the user should be asked to reproduce the
566# problem without these.
567#
568# Not all ebuilds do call this function, so placing patches in the
569# stated directory might or might not work, depending on the package and
570# the eclasses it inherits and uses. It is safe to call the function
571# repeatedly, so it is always possible to add a call at the ebuild
572# level. The first call is the time when the patches will be
573# applied.
574#
575# Ideally, this function should be called after gentoo-specific patches
576# have been applied, so that their code can be modified as well, but
577# before calls to e.g. eautoreconf, as the user patches might affect
578# autotool input files as well.
579epatch_user() {
580 [[ $# -ne 0 ]] && die "epatch_user takes no options"
581
582 # Allow multiple calls to this function; ignore all but the first
583 local applied="${T}/epatch_user.log"
584 [[ -e ${applied} ]] && return 2
585
586 # don't clobber any EPATCH vars that the parent might want
587 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
588 for check in ${CATEGORY}/{${P}-${PR},${P},${PN}}; do
589 EPATCH_SOURCE=${base}/${CTARGET}/${check}
590 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
591 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
592 if [[ -d ${EPATCH_SOURCE} ]] ; then
593 EPATCH_SOURCE=${EPATCH_SOURCE} \
191 PATCH_SUFFIX="patch" 594 EPATCH_SUFFIX="patch" \
595 EPATCH_FORCE="yes" \
596 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
597 epatch
598 echo "${EPATCH_SOURCE}" > "${applied}"
599 return 0
600 fi
601 done
602 echo "none" > "${applied}"
603 return 1
604}
605
606# @FUNCTION: emktemp
607# @USAGE: [temp dir]
608# @DESCRIPTION:
609# Cheap replacement for when debianutils (and thus mktemp)
610# does not exist on the users system.
611emktemp() {
612 local exe="touch"
613 [[ $1 == -d ]] && exe="mkdir" && shift
614 local topdir=$1
615
616 if [[ -z ${topdir} ]] ; then
617 [[ -z ${T} ]] \
618 && topdir="/tmp" \
619 || topdir=${T}
620 fi
621
622 if ! type -P mktemp > /dev/null ; then
623 # system lacks `mktemp` so we have to fake it
624 local tmp=/
625 while [[ -e ${tmp} ]] ; do
626 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}
627 done
628 ${exe} "${tmp}" || ${exe} -p "${tmp}"
629 echo "${tmp}"
630 else
631 # the args here will give slightly wierd names on BSD,
632 # but should produce a usable file on all userlands
633 if [[ ${exe} == "touch" ]] ; then
634 TMPDIR="${topdir}" mktemp -t tmp.XXXXXXXXXX
635 else
636 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX
637 fi
638 fi
639}
640
641# @FUNCTION: edos2unix
642# @USAGE: <file> [more files ...]
643# @DESCRIPTION:
644# A handy replacement for dos2unix, recode, fixdos, etc... This allows you
645# to remove all of these text utilities from DEPEND variables because this
646# is a script based solution. Just give it a list of files to convert and
647# they will all be changed from the DOS CRLF format to the UNIX LF format.
648edos2unix() {
649 [[ $# -eq 0 ]] && return 0
650 sed -i 's/\r$//' -- "$@" || die
651}
652
653# @FUNCTION: make_desktop_entry
654# @USAGE: make_desktop_entry(<command>, [name], [icon], [type], [fields])
655# @DESCRIPTION:
656# Make a .desktop file.
657#
658# @CODE
659# binary: what command does the app run with ?
660# name: the name that will show up in the menu
661# icon: give your little like a pretty little icon ...
662# this can be relative (to /usr/share/pixmaps) or
663# a full path to an icon
664# type: what kind of application is this?
665# for categories:
666# http://standards.freedesktop.org/menu-spec/latest/apa.html
667# if unset, function tries to guess from package's category
668# fields: extra fields to append to the desktop file; a printf string
669# @CODE
670make_desktop_entry() {
671 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
672
673 local exec=${1}
674 local name=${2:-${PN}}
675 local icon=${3:-${PN}}
676 local type=${4}
677 local fields=${5}
678
679 if [[ -z ${type} ]] ; then
680 local catmaj=${CATEGORY%%-*}
681 local catmin=${CATEGORY##*-}
682 case ${catmaj} in
683 app)
684 case ${catmin} in
685 accessibility) type="Utility;Accessibility";;
686 admin) type=System;;
687 antivirus) type=System;;
688 arch) type="Utility;Archiving";;
689 backup) type="Utility;Archiving";;
690 cdr) type="AudioVideo;DiscBurning";;
691 dicts) type="Office;Dictionary";;
692 doc) type=Documentation;;
693 editors) type="Utility;TextEditor";;
694 emacs) type="Development;TextEditor";;
695 emulation) type="System;Emulator";;
696 laptop) type="Settings;HardwareSettings";;
697 office) type=Office;;
698 pda) type="Office;PDA";;
699 vim) type="Development;TextEditor";;
700 xemacs) type="Development;TextEditor";;
701 esac
192 ;; 702 ;;
703
704 dev)
705 type="Development"
706 ;;
707
708 games)
709 case ${catmin} in
710 action|fps) type=ActionGame;;
711 arcade) type=ArcadeGame;;
712 board) type=BoardGame;;
713 emulation) type=Emulator;;
714 kids) type=KidsGame;;
715 puzzle) type=LogicGame;;
716 roguelike) type=RolePlaying;;
717 rpg) type=RolePlaying;;
718 simulation) type=Simulation;;
719 sports) type=SportsGame;;
720 strategy) type=StrategyGame;;
721 esac
722 type="Game;${type}"
723 ;;
724
725 gnome)
726 type="Gnome;GTK"
727 ;;
728
729 kde)
730 type="KDE;Qt"
731 ;;
732
733 mail)
734 type="Network;Email"
735 ;;
736
737 media)
738 case ${catmin} in
739 gfx)
740 type=Graphics
741 ;;
742 *)
743 case ${catmin} in
744 radio) type=Tuner;;
745 sound) type=Audio;;
746 tv) type=TV;;
747 video) type=Video;;
748 esac
749 type="AudioVideo;${type}"
750 ;;
751 esac
752 ;;
753
754 net)
755 case ${catmin} in
756 dialup) type=Dialup;;
757 ftp) type=FileTransfer;;
758 im) type=InstantMessaging;;
759 irc) type=IRCClient;;
760 mail) type=Email;;
761 news) type=News;;
762 nntp) type=News;;
763 p2p) type=FileTransfer;;
764 voip) type=Telephony;;
765 esac
766 type="Network;${type}"
767 ;;
768
769 sci)
770 case ${catmin} in
771 astro*) type=Astronomy;;
772 bio*) type=Biology;;
773 calc*) type=Calculator;;
774 chem*) type=Chemistry;;
775 elec*) type=Electronics;;
776 geo*) type=Geology;;
777 math*) type=Math;;
778 physics) type=Physics;;
779 visual*) type=DataVisualization;;
780 esac
781 type="Education;Science;${type}"
782 ;;
783
784 sys)
785 type="System"
786 ;;
787
788 www)
789 case ${catmin} in
790 client) type=WebBrowser;;
791 esac
792 type="Network;${type}"
793 ;;
794
795 *)
796 type=
797 ;;
193 esac 798 esac
799 fi
800 if [ "${SLOT}" == "0" ] ; then
801 local desktop_name="${PN}"
802 else
803 local desktop_name="${PN}-${SLOT}"
804 fi
805 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
806 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
194 807
195 if [ "${SINGLE_PATCH}" = "no" ] 808 # Don't append another ";" when a valid category value is provided.
196 then 809 type=${type%;}${type:+;}
197 einfo "Applying various patches (bugfixes/updates)..." 810
811 eshopts_push -s extglob
812 if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
813 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
814 ewarn "allowed in .desktop files if the value is not an absolute path."
815 icon=${icon%.@(xpm|png|svg)}
816 fi
817 eshopts_pop
818
819 cat <<-EOF > "${desktop}"
820 [Desktop Entry]
821 Name=${name}
822 Type=Application
823 Comment=${DESCRIPTION}
824 Exec=${exec}
825 TryExec=${exec%% *}
826 Icon=${icon}
827 Categories=${type}
828 EOF
829
830 if [[ ${fields:-=} != *=* ]] ; then
831 # 5th arg used to be value to Path=
832 ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
833 fields="Path=${fields}"
834 fi
835 [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
836
837 (
838 # wrap the env here so that the 'insinto' call
839 # doesn't corrupt the env of the caller
840 insinto /usr/share/applications
841 doins "${desktop}"
842 ) || die "installing desktop file failed"
843}
844
845# @FUNCTION: validate_desktop_entries
846# @USAGE: [directories]
847# @MAINTAINER:
848# Carsten Lohrke <carlo@gentoo.org>
849# @DESCRIPTION:
850# Validate desktop entries using desktop-file-utils
851validate_desktop_entries() {
852 if [[ -x /usr/bin/desktop-file-validate ]] ; then
853 einfo "Checking desktop entry validity"
854 local directories=""
855 for d in /usr/share/applications $@ ; do
856 [[ -d ${D}${d} ]] && directories="${directories} ${D}${d}"
857 done
858 if [[ -n ${directories} ]] ; then
859 for FILE in $(find ${directories} -name "*\.desktop" \
860 -not -path '*.hidden*' | sort -u 2>/dev/null)
861 do
862 local temp=$(desktop-file-validate ${FILE} | grep -v "warning:" | \
863 sed -e "s|error: ||" -e "s|${FILE}:|--|g" )
864 [[ -n $temp ]] && elog ${temp/--/${FILE/${D}/}:}
865 done
198 fi 866 fi
199 for x in ${EPATCH_SOURCE} 867 echo ""
868 else
869 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
870 fi
871}
872
873# @FUNCTION: make_session_desktop
874# @USAGE: <title> <command> [command args...]
875# @DESCRIPTION:
876# Make a GDM/KDM Session file. The title is the file to execute to start the
877# Window Manager. The command is the name of the Window Manager.
878#
879# You can set the name of the file via the ${wm} variable.
880make_session_desktop() {
881 [[ -z $1 ]] && eerror "$0: You must specify the title" && return 1
882 [[ -z $2 ]] && eerror "$0: You must specify the command" && return 1
883
884 local title=$1
885 local command=$2
886 local desktop=${T}/${wm:-${PN}}.desktop
887 shift 2
888
889 cat <<-EOF > "${desktop}"
890 [Desktop Entry]
891 Name=${title}
892 Comment=This session logs you into ${title}
893 Exec=${command} $*
894 TryExec=${command}
895 Type=XSession
896 EOF
897
898 (
899 # wrap the env here so that the 'insinto' call
900 # doesn't corrupt the env of the caller
901 insinto /usr/share/xsessions
902 doins "${desktop}"
903 )
904}
905
906# @FUNCTION: domenu
907# @USAGE: <menus>
908# @DESCRIPTION:
909# Install the list of .desktop menu files into the appropriate directory
910# (/usr/share/applications).
911domenu() {
912 (
913 # wrap the env here so that the 'insinto' call
914 # doesn't corrupt the env of the caller
915 local i j ret=0
916 insinto /usr/share/applications
917 for i in "$@" ; do
918 if [[ -f ${i} ]] ; then
919 doins "${i}"
920 ((ret+=$?))
921 elif [[ -d ${i} ]] ; then
922 for j in "${i}"/*.desktop ; do
923 doins "${j}"
924 ((ret+=$?))
925 done
926 else
927 ((++ret))
928 fi
200 do 929 done
201 # New ARCH dependant patch naming scheme... 930 exit ${ret}
202 # 931 )
203 # ???_arch_foo.patch 932}
204 #
205 if [ -f ${x} ] && \
206 [ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "`eval echo \$\{x/_${ARCH}_\}`" != "${x}" ]
207 then
208 local count=0
209 local popts="${EPATCH_OPTS}"
210 933
211 if [ -n "${EPATCH_EXCLUDE}" ] 934# @FUNCTION: newmenu
212 then 935# @USAGE: <menu> <newname>
213 if [ "`eval echo \$\{EPATCH_EXCLUDE/${x##*/}\}`" != "${EPATCH_EXCLUDE}" ] 936# @DESCRIPTION:
214 then 937# Like all other new* functions, install the specified menu as newname.
215 continue 938newmenu() {
939 (
940 # wrap the env here so that the 'insinto' call
941 # doesn't corrupt the env of the caller
942 insinto /usr/share/applications
943 newins "$@"
944 )
945}
946
947# @FUNCTION: doicon
948# @USAGE: <list of icons>
949# @DESCRIPTION:
950# Install the list of icons into the icon directory (/usr/share/pixmaps).
951# This is useful in conjunction with creating desktop/menu files.
952doicon() {
953 (
954 # wrap the env here so that the 'insinto' call
955 # doesn't corrupt the env of the caller
956 local i j ret
957 insinto /usr/share/pixmaps
958 for i in "$@" ; do
959 if [[ -f ${i} ]] ; then
960 doins "${i}"
961 ((ret+=$?))
962 elif [[ -d ${i} ]] ; then
963 for j in "${i}"/*.png ; do
964 doins "${j}"
965 ((ret+=$?))
966 done
967 else
968 ((++ret))
969 fi
970 done
971 exit ${ret}
972 )
973}
974
975# @FUNCTION: newicon
976# @USAGE: <icon> <newname>
977# @DESCRIPTION:
978# Like all other new* functions, install the specified icon as newname.
979newicon() {
980 (
981 # wrap the env here so that the 'insinto' call
982 # doesn't corrupt the env of the caller
983 insinto /usr/share/pixmaps
984 newins "$@"
985 )
986}
987
988# @FUNCTION: strip-linguas
989# @USAGE: [<allow LINGUAS>|<-i|-u> <directories of .po files>]
990# @DESCRIPTION:
991# Make sure that LINGUAS only contains languages that
992# a package can support. The first form allows you to
993# specify a list of LINGUAS. The -i builds a list of po
994# files found in all the directories and uses the
995# intersection of the lists. The -u builds a list of po
996# files found in all the directories and uses the union
997# of the lists.
998strip-linguas() {
999 local ls newls nols
1000 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1001 local op=$1; shift
1002 ls=$(find "$1" -name '*.po' -exec basename {} .po ';'); shift
1003 local d f
1004 for d in "$@" ; do
1005 if [[ ${op} == "-u" ]] ; then
1006 newls=${ls}
1007 else
1008 newls=""
1009 fi
1010 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1011 if [[ ${op} == "-i" ]] ; then
1012 has ${f} ${ls} && newls="${newls} ${f}"
1013 else
1014 has ${f} ${ls} || newls="${newls} ${f}"
216 fi 1015 fi
217 fi
218
219 if [ "${SINGLE_PATCH}" = "yes" ]
220 then
221 if [ -n "${EPATCH_SINGLE_MSG}" ]
222 then
223 einfo "${EPATCH_SINGLE_MSG}"
224 else
225 einfo "Applying ${x##*/}..."
226 fi
227 else
228 einfo " ${x##*/}..."
229 fi
230
231 echo "***** ${x##*/} *****" > ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
232 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
233
234 # Allow for prefix to differ ... im lazy, so shoot me :/
235 while [ "${count}" -lt 5 ]
236 do
237 # Generate some useful debug info ...
238 draw_line "***** ${x##*/} *****" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
239 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
240
241 if [ "${PATCH_SUFFIX}" != "patch" ]
242 then
243 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
244 echo "${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
245 else
246 PATCH_TARGET="${x}"
247 fi
248
249 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
250 echo "patch ${popts} -p${count} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
251
252 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
253 draw_line "***** ${x##*/} *****" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
254
255 if [ "${PATCH_SUFFIX}" != "patch" ]
256 then
257 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 2>&1
258 then
259 echo
260 eerror "Could not extract patch!"
261 #die "Could not extract patch!"
262 count=5
263 break
264 fi
265 fi
266
267 if (cat ${PATCH_TARGET} | patch ${popts} --dry-run -f -p${count}) >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 2>&1
268 then
269 draw_line "***** ${x##*/} *****" > ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
270 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
271 echo "ACTUALLY APPLYING ${x##*/}..." >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
272 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
273 draw_line "***** ${x##*/} *****" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
274
275 cat ${PATCH_TARGET} | patch ${popts} -p${count} >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real 2>&1
276
277 if [ "$?" -ne 0 ]
278 then
279 cat ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
280 echo
281 eerror "A dry-run of patch command succeeded, but actually"
282 eerror "applying the patch failed!"
283 #die "Real world sux compared to the dreamworld!"
284 count=5
285 fi
286
287 rm -f ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
288
289 break
290 fi
291
292 count=$((count + 1))
293 done 1016 done
294 1017 ls=${newls}
295 if [ "${PATCH_SUFFIX}" != "patch" ] 1018 done
296 then 1019 else
297 rm -f ${PATCH_TARGET} 1020 ls="$@"
298 fi 1021 fi
299 1022
300 if [ "${count}" -eq 5 ] 1023 nols=""
301 then 1024 newls=""
302 echo 1025 for f in ${LINGUAS} ; do
303 eerror "Failed Patch: ${x##*/}!" 1026 if has ${f} ${ls} ; then
304 eerror 1027 newls="${newls} ${f}"
305 eerror "Include in your bugreport the contents of:" 1028 else
306 eerror 1029 nols="${nols} ${f}"
307 eerror " ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}"
308 echo
309 die "Failed Patch: ${x##*/}!"
310 fi
311
312 rm -f ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
313
314 eend 0
315 fi 1030 fi
316 done 1031 done
317 if [ "${SINGLE_PATCH}" = "no" ] 1032 [[ -n ${nols} ]] \
318 then 1033 && einfo "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
319 einfo "Done with patching" 1034 export LINGUAS=${newls:1}
320 fi
321} 1035}
322 1036
323# This function check how many cpu's are present, and then set 1037# @FUNCTION: preserve_old_lib
324# -j in MAKEOPTS accordingly. 1038# @USAGE: <libs to preserve> [more libs]
325# 1039# @DESCRIPTION:
326# Thanks to nall <nall@gentoo.org> for this. 1040# These functions are useful when a lib in your package changes ABI SONAME.
327# 1041# An example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0
328get_number_of_jobs() { 1042# would break packages that link against it. Most people get around this
329 local jobs=0 1043# by using the portage SLOT mechanism, but that is not always a relevant
330 1044# solution, so instead you can call this from pkg_preinst. See also the
331 if [ ! -r /proc/cpuinfo ] 1045# preserve_old_lib_notify function.
332 then 1046preserve_old_lib() {
333 return 1 1047 if [[ ${EBUILD_PHASE} != "preinst" ]] ; then
334 fi 1048 eerror "preserve_old_lib() must be called from pkg_preinst() only"
335 1049 die "Invalid preserve_old_lib() usage"
336 # This bit is from H?kan Wessberg <nacka-gentoo@refug.org>, bug #13565.
337 if [ "`egrep "^[[:space:]]*MAKEOPTS=" /etc/make.conf | wc -l`" -gt 0 ]
338 then
339 ADMINOPTS="`egrep "^[[:space:]]*MAKEOPTS=" /etc/make.conf | cut -d= -f2 | sed 's/\"//g'`"
340 ADMINPARAM="`echo ${ADMINOPTS} | gawk '{match($0, /-j *[0-9]*/, opt); print opt[0]}'`"
341 ADMINPARAM="${ADMINPARAM/-j}"
342 fi
343
344 export MAKEOPTS="`echo ${MAKEOPTS} | sed -e 's:-j *[0-9]*::g'`"
345
346 if [ "${ARCH}" = "x86" -o "${ARCH}" = "hppa" -o \
347 "${ARCH}" = "arm" -o "${ARCH}" = "mips" ]
348 then
349 # these archs will always have "[Pp]rocessor"
350 jobs="$((`grep -c ^[Pp]rocessor /proc/cpuinfo` * 2))"
351
352 elif [ "${ARCH}" = "sparc" -o "${ARCH}" = "sparc64" ]
353 then
354 # sparc always has "ncpus active"
355 jobs="$((`grep "^ncpus active" /proc/cpuinfo | sed -e "s/^.*: //"` * 2))"
356
357 elif [ "${ARCH}" = "alpha" ]
358 then
359 # alpha has "cpus active", but only when compiled with SMP
360 if [ "`grep -c "^cpus active" /proc/cpuinfo`" -eq 1 ]
361 then
362 jobs="$((`grep "^cpus active" /proc/cpuinfo | sed -e "s/^.*: //"` * 2))"
363 else
364 jobs=2
365 fi 1050 fi
366 1051 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]"
367 elif [ "${ARCH}" = "ppc" ] 1052
368 then 1053 # let portage worry about it
369 # ppc has "processor", but only when compiled with SMP 1054 has preserve-libs ${FEATURES} && return 0
370 if [ "`grep -c "^processor" /proc/cpuinfo`" -eq 1 ] 1055
371 then 1056 local lib dir
372 jobs="$((`grep -c ^processor /proc/cpuinfo` * 2))" 1057 for lib in "$@" ; do
373 else 1058 [[ -e ${ROOT}/${lib} ]] || continue
374 jobs=2 1059 dir=${lib%/*}
1060 dodir ${dir} || die "dodir ${dir} failed"
1061 cp "${ROOT}"/${lib} "${D}"/${lib} || die "cp ${lib} failed"
1062 touch "${D}"/${lib}
1063 done
1064}
1065
1066# @FUNCTION: preserve_old_lib_notify
1067# @USAGE: <libs to notify> [more libs]
1068# @DESCRIPTION:
1069# Spit helpful messages about the libraries preserved by preserve_old_lib.
1070preserve_old_lib_notify() {
1071 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then
1072 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only"
1073 die "Invalid preserve_old_lib_notify() usage"
375 fi 1074 fi
376 else 1075
377 jobs="$((`grep -c ^cpu /proc/cpuinfo` * 2))" 1076 # let portage worry about it
378 die "Unknown ARCH -- ${ARCH}!" 1077 has preserve-libs ${FEATURES} && return 0
1078
1079 local lib notice=0
1080 for lib in "$@" ; do
1081 [[ -e ${ROOT}/${lib} ]] || continue
1082 if [[ ${notice} -eq 0 ]] ; then
1083 notice=1
1084 ewarn "Old versions of installed libraries were detected on your system."
1085 ewarn "In order to avoid breaking packages that depend on these old libs,"
1086 ewarn "the libraries are not being removed. You need to run revdep-rebuild"
1087 ewarn "in order to remove these old dependencies. If you do not have this"
1088 ewarn "helper program, simply emerge the 'gentoolkit' package."
1089 ewarn
379 fi 1090 fi
380 1091 # temp hack for #348634 #357225
381 # Make sure the number is valid ... 1092 [[ ${PN} == "mpfr" ]] && lib=${lib##*/}
382 if [ "${jobs}" -lt 1 ] 1093 ewarn " # revdep-rebuild --library '${lib}'"
383 then 1094 done
384 jobs=1 1095 if [[ ${notice} -eq 1 ]] ; then
385 fi 1096 ewarn
386 1097 ewarn "Once you've finished running revdep-rebuild, it should be safe to"
387 if [ -n "${ADMINPARAM}" ] 1098 ewarn "delete the old libraries. Here is a copy & paste for the lazy:"
388 then 1099 for lib in "$@" ; do
389 if [ "${jobs}" -gt "${ADMINPARAM}" ] 1100 ewarn " # rm '${lib}'"
390 then 1101 done
391 einfo "Setting make jobs to \"-j${ADMINPARAM}\" to ensure successful merge..."
392 export MAKEOPTS="${MAKEOPTS} -j${ADMINPARAM}"
393 else
394 einfo "Setting make jobs to \"-j${jobs}\" to ensure successful merge..."
395 export MAKEOPTS="${MAKEOPTS} -j${jobs}"
396 fi 1102 fi
397 fi
398} 1103}
399 1104
400# Simplify/standardize adding users to the system 1105# @FUNCTION: built_with_use
401# vapier@gentoo.org 1106# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1107# @DESCRIPTION:
402# 1108#
403# enewuser(username, uid, shell, homedir, groups, extra options) 1109# Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
404# 1110#
405# Default values if you do not specify any: 1111# A temporary hack until portage properly supports DEPENDing on USE
406# username: REQUIRED ! 1112# flags being enabled in packages. This will check to see if the specified
407# uid: next available (see useradd(8)) 1113# DEPEND atom was built with the specified list of USE flags. The
408# shell: /bin/false 1114# --missing option controls the behavior if called on a package that does
409# homedir: /dev/null 1115# not actually support the defined USE flags (aka listed in IUSE).
410# groups: none 1116# The default is to abort (call die). The -a and -o flags control
411# extra: comment of 'added by portage for ${PN}' 1117# the requirements of the USE flags. They correspond to "and" and "or"
412enewuser() { 1118# logic. So the -a flag means all listed USE flags must be enabled
413 # get the username 1119# while the -o flag means at least one of the listed IUSE flags must be
414 local euser="$1"; shift 1120# enabled. The --hidden option is really for internal use only as it
415 if [ -z "${euser}" ] ; then 1121# means the USE flag we're checking is hidden expanded, so it won't be found
416 eerror "No username specified !" 1122# in IUSE like normal USE flags.
417 die "Cannot call enewuser without a username" 1123#
418 fi 1124# Remember that this function isn't terribly intelligent so order of optional
419 einfo "Adding user '${euser}' to your system ..." 1125# flags matter.
420 1126built_with_use() {
421 # setup a file for testing usernames/groups 1127 local hidden="no"
422 local tmpfile="`mktemp -p ${T}`" 1128 if [[ $1 == "--hidden" ]] ; then
423 touch ${tmpfile} 1129 hidden="yes"
424 chown ${euser} ${tmpfile} >& /dev/null 1130 shift
425 local realuser="`ls -l ${tmpfile} | awk '{print $3}'`"
426
427 # see if user already exists
428 if [ "${euser}" == "${realuser}" ] ; then
429 einfo "${euser} already exists on your system :)"
430 return 0
431 fi
432
433 # options to pass to useradd
434 local opts=""
435
436 # handle uid
437 local euid="$1"; shift
438 if [ ! -z "${euid}" ] ; then
439 if [ ${euid} -gt 0 ] ; then
440 opts="${opts} -u ${euid}"
441 else
442 eerror "Userid given but is not greater than 0 !"
443 die "${euid} is not a valid UID"
444 fi 1131 fi
445 else
446 euid="next available"
447 fi
448 einfo " - Userid: ${euid}"
449 1132
450 # handle shell 1133 local missing_action="die"
451 local eshell="$1"; shift 1134 if [[ $1 == "--missing" ]] ; then
452 if [ ! -z "${eshell}" ] ; then 1135 missing_action=$2
453 if [ ! -e ${eshell} ] ; then 1136 shift ; shift
454 eerror "A shell was specified but it does not exist !" 1137 case ${missing_action} in
455 die "${eshell} does not exist" 1138 true|false|die) ;;
1139 *) die "unknown action '${missing_action}'";;
1140 esac
456 fi 1141 fi
457 else
458 eshell=/bin/false
459 fi
460 einfo " - Shell: ${eshell}"
461 opts="${opts} -s ${eshell}"
462 1142
463 # handle homedir 1143 local opt=$1
464 local ehome="$1"; shift 1144 [[ ${opt:0:1} = "-" ]] && shift || opt="-a"
465 if [ -z "${ehome}" ] ; then
466 ehome=/dev/null
467 fi
468 einfo " - Home: ${ehome}"
469 opts="${opts} -d ${ehome}"
470 1145
471 # handle groups 1146 local PKG=$(best_version $1)
472 local egroups="$1"; shift 1147 [[ -z ${PKG} ]] && die "Unable to resolve $1 to an installed package"
473 if [ ! -z "${egroups}" ] ; then 1148 shift
474 local realgroup 1149
475 local oldifs="${IFS}" 1150 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE
476 export IFS="," 1151 local IUSEFILE=${ROOT}/var/db/pkg/${PKG}/IUSE
477 for g in ${egroups} ; do 1152
478 chgrp ${g} ${tmpfile} >& /dev/null 1153 # if the IUSE file doesn't exist, the read will error out, we need to handle
479 realgroup="`ls -l ${tmpfile} | awk '{print $4}'`" 1154 # this gracefully
480 if [ "${g}" != "${realgroup}" ] ; then 1155 if [[ ! -e ${USEFILE} ]] || [[ ! -e ${IUSEFILE} && ${hidden} == "no" ]] ; then
481 eerror "You must add ${g} to the system first" 1156 case ${missing_action} in
482 die "${g} is not a valid GID" 1157 true) return 0;;
1158 false) return 1;;
1159 die) die "Unable to determine what USE flags $PKG was built with";;
1160 esac
1161 fi
1162
1163 if [[ ${hidden} == "no" ]] ; then
1164 local IUSE_BUILT=( $(<"${IUSEFILE}") )
1165 # Don't check USE_EXPAND #147237
1166 local expand
1167 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do
1168 if [[ $1 == ${expand}_* ]] ; then
1169 expand=""
1170 break
483 fi 1171 fi
484 done 1172 done
485 export IFS="${oldifs}" 1173 if [[ -n ${expand} ]] ; then
486 opts="${opts} -g ${egroups}" 1174 if ! has $1 ${IUSE_BUILT[@]#[-+]} ; then
1175 case ${missing_action} in
1176 true) return 0;;
1177 false) return 1;;
1178 die) die "$PKG does not actually support the $1 USE flag!";;
1179 esac
1180 fi
1181 fi
1182 fi
1183
1184 local USE_BUILT=$(<${USEFILE})
1185 while [[ $# -gt 0 ]] ; do
1186 if [[ ${opt} = "-o" ]] ; then
1187 has $1 ${USE_BUILT} && return 0
1188 else
1189 has $1 ${USE_BUILT} || return 1
1190 fi
1191 shift
1192 done
1193 [[ ${opt} = "-a" ]]
1194}
1195
1196# @FUNCTION: epunt_cxx
1197# @USAGE: [dir to scan]
1198# @DESCRIPTION:
1199# Many configure scripts wrongly bail when a C++ compiler could not be
1200# detected. If dir is not specified, then it defaults to ${S}.
1201#
1202# http://bugs.gentoo.org/73450
1203epunt_cxx() {
1204 local dir=$1
1205 [[ -z ${dir} ]] && dir=${S}
1206 ebegin "Removing useless C++ checks"
1207 local f
1208 find "${dir}" -name configure | while read f ; do
1209 patch --no-backup-if-mismatch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null
1210 done
1211 eend 0
1212}
1213
1214# @FUNCTION: make_wrapper
1215# @USAGE: <wrapper> <target> [chdir] [libpaths] [installpath]
1216# @DESCRIPTION:
1217# Create a shell wrapper script named wrapper in installpath
1218# (defaults to the bindir) to execute target (default of wrapper) by
1219# first optionally setting LD_LIBRARY_PATH to the colon-delimited
1220# libpaths followed by optionally changing directory to chdir.
1221make_wrapper() {
1222 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5
1223 local tmpwrapper=$(emktemp)
1224 # We don't want to quote ${bin} so that people can pass complex
1225 # things as $bin ... "./someprog --args"
1226 cat << EOF > "${tmpwrapper}"
1227#!/bin/sh
1228cd "${chdir:-.}"
1229if [ -n "${libdir}" ] ; then
1230 if [ "\${LD_LIBRARY_PATH+set}" = "set" ] ; then
1231 export LD_LIBRARY_PATH="\${LD_LIBRARY_PATH}:${libdir}"
487 else 1232 else
488 egroups="(none)" 1233 export LD_LIBRARY_PATH="${libdir}"
1234 fi
489 fi 1235fi
490 einfo " - Groups: ${egroups}" 1236exec ${bin} "\$@"
491 1237EOF
492 # handle extra and add the user 1238 chmod go+rx "${tmpwrapper}"
493 local eextra="$@" 1239 if [[ -n ${path} ]] ; then
494 local oldsandbox="${oldsandbox}" 1240 (
495 export SANDBOX_ON="0" 1241 exeinto "${path}"
496 if [ -z "${eextra}" ] ; then 1242 newexe "${tmpwrapper}" "${wrapper}"
497 useradd ${opts} ${euser} \ 1243 ) || die
498 -c "added by portage for ${PN}" \
499 || die "enewuser failed"
500 else 1244 else
501 einfo " - Extra: ${eextra}" 1245 newbin "${tmpwrapper}" "${wrapper}" || die
502 useradd ${opts} ${euser} ${eextra} \
503 || die "enewuser failed"
504 fi
505 export SANDBOX_ON="${oldsandbox}"
506
507 if [ ! -e ${ehome} ] && [ ! -e ${D}/${ehome} ] ; then
508 einfo " - Creating ${ehome} in ${D}"
509 dodir ${ehome}
510 fperms ${euser} ${ehome}
511 fi
512}
513
514# Simplify/standardize adding groups to the system
515# vapier@gentoo.org
516#
517# enewgroup(group, gid)
518#
519# Default values if you do not specify any:
520# groupname: REQUIRED !
521# gid: next available (see groupadd(8))
522# extra: none
523enewgroup() {
524 # get the group
525 local egroup="$1"; shift
526 if [ -z "${egroup}" ] ; then
527 eerror "No group specified !"
528 die "Cannot call enewgroup without a group"
529 fi
530 einfo "Adding group '${egroup}' to your system ..."
531
532 # setup a file for testing groupname
533 local tmpfile="`mktemp -p ${T}`"
534 touch ${tmpfile}
535 chgrp ${egroup} ${tmpfile} >& /dev/null
536 local realgroup="`ls -l ${tmpfile} | awk '{print $4}'`"
537
538 # see if group already exists
539 if [ "${egroup}" == "${realgroup}" ] ; then
540 einfo "${egroup} already exists on your system :)"
541 return 0
542 fi
543
544 # options to pass to useradd
545 local opts=""
546
547 # handle gid
548 local egid="$1"; shift
549 if [ ! -z "${egid}" ] ; then
550 if [ ${egid} -gt 0 ] ; then
551 opts="${opts} -g ${egid}"
552 else
553 eerror "Groupid given but is not greater than 0 !"
554 die "${egid} is not a valid GID"
555 fi 1246 fi
556 else 1247}
557 egid="next available" 1248
1249# @FUNCTION: path_exists
1250# @USAGE: [-a|-o] <paths>
1251# @DESCRIPTION:
1252# Check if the specified paths exist. Works for all types of paths
1253# (files/dirs/etc...). The -a and -o flags control the requirements
1254# of the paths. They correspond to "and" and "or" logic. So the -a
1255# flag means all the paths must exist while the -o flag means at least
1256# one of the paths must exist. The default behavior is "and". If no
1257# paths are specified, then the return value is "false".
1258path_exists() {
1259 local opt=$1
1260 [[ ${opt} == -[ao] ]] && shift || opt="-a"
1261
1262 # no paths -> return false
1263 # same behavior as: [[ -e "" ]]
1264 [[ $# -eq 0 ]] && return 1
1265
1266 local p r=0
1267 for p in "$@" ; do
1268 [[ -e ${p} ]]
1269 : $(( r += $? ))
1270 done
1271
1272 case ${opt} in
1273 -a) return $(( r != 0 )) ;;
1274 -o) return $(( r == $# )) ;;
1275 esac
1276}
1277
1278# @FUNCTION: in_iuse
1279# @USAGE: <flag>
1280# @DESCRIPTION:
1281# Determines whether the given flag is in IUSE. Strips IUSE default prefixes
1282# as necessary.
1283#
1284# Note that this function should not be used in the global scope.
1285in_iuse() {
1286 debug-print-function ${FUNCNAME} "${@}"
1287 [[ ${#} -eq 1 ]] || die "Invalid args to ${FUNCNAME}()"
1288
1289 local flag=${1}
1290 local liuse=( ${IUSE} )
1291
1292 has "${flag}" "${liuse[@]#[+-]}"
1293}
1294
1295# @FUNCTION: use_if_iuse
1296# @USAGE: <flag>
1297# @DESCRIPTION:
1298# Return true if the given flag is in USE and IUSE.
1299#
1300# Note that this function should not be used in the global scope.
1301use_if_iuse() {
1302 in_iuse $1 || return 1
1303 use $1
1304}
1305
1306# @FUNCTION: usex
1307# @USAGE: <USE flag> [true output] [false output] [true suffix] [false suffix]
1308# @DESCRIPTION:
1309# If USE flag is set, echo [true output][true suffix] (defaults to "yes"),
1310# otherwise echo [false output][false suffix] (defaults to "no").
1311usex() { use "$1" && echo "${2-yes}$4" || echo "${3-no}$5" ; } #382963
1312
1313# @FUNCTION: makeopts_jobs
1314# @USAGE: [${MAKEOPTS}]
1315# @DESCRIPTION:
1316# Searches the arguments (defaults to ${MAKEOPTS}) and extracts the jobs number
1317# specified therein. Useful for running non-make tools in parallel too.
1318# i.e. if the user has MAKEOPTS=-j9, this will show "9".
1319# We can't return the number as bash normalizes it to [0, 255]. If the flags
1320# haven't specified a -j flag, then "1" is shown as that is the default `make`
1321# uses. Since there's no way to represent infinity, we return 999 if the user
1322# has -j without a number.
1323makeopts_jobs() {
1324 [[ $# -eq 0 ]] && set -- ${MAKEOPTS}
1325 # This assumes the first .* will be more greedy than the second .*
1326 # since POSIX doesn't specify a non-greedy match (i.e. ".*?").
1327 local jobs=$(echo " $* " | sed -r -n \
1328 -e 's:.*[[:space:]](-j|--jobs[=[:space:]])[[:space:]]*([0-9]+).*:\2:p' \
1329 -e 's:.*[[:space:]](-j|--jobs)[[:space:]].*:999:p')
1330 echo ${jobs:-1}
1331}
1332
1333check_license() { die "you no longer need this as portage supports ACCEPT_LICENSE itself"; }
1334
558 fi 1335fi
559 einfo " - Groupid: ${egid}"
560
561 # handle extra
562 local eextra="$@"
563 opts="${opts} ${eextra}"
564
565 # add the group
566 local oldsandbox="${oldsandbox}"
567 export SANDBOX_ON="0"
568 groupadd ${opts} ${egroup} || die "enewgroup failed"
569 export SANDBOX_ON="${oldsandbox}"
570}

Legend:
Removed from v.1.23  
changed lines
  Added in v.1.392

  ViewVC Help
Powered by ViewVC 1.1.20